# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConsumerChannelArgs', 'ConsumerChannel']

@pulumi.input_type
class ConsumerChannelArgs:
    def __init__(__self__, *,
                 consumer_group_name: pulumi.Input[str],
                 consumer_group_password: pulumi.Input[str],
                 consumer_group_user_name: pulumi.Input[str],
                 dts_instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ConsumerChannel resource.
        :param pulumi.Input[str] consumer_group_name: The name of the consumer group.
        :param pulumi.Input[str] consumer_group_password: The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        :param pulumi.Input[str] consumer_group_user_name: The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        :param pulumi.Input[str] dts_instance_id: The ID of the subscription instance.
        """
        ConsumerChannelArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            consumer_group_name=consumer_group_name,
            consumer_group_password=consumer_group_password,
            consumer_group_user_name=consumer_group_user_name,
            dts_instance_id=dts_instance_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             consumer_group_name: Optional[pulumi.Input[str]] = None,
             consumer_group_password: Optional[pulumi.Input[str]] = None,
             consumer_group_user_name: Optional[pulumi.Input[str]] = None,
             dts_instance_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if consumer_group_name is None and 'consumerGroupName' in kwargs:
            consumer_group_name = kwargs['consumerGroupName']
        if consumer_group_name is None:
            raise TypeError("Missing 'consumer_group_name' argument")
        if consumer_group_password is None and 'consumerGroupPassword' in kwargs:
            consumer_group_password = kwargs['consumerGroupPassword']
        if consumer_group_password is None:
            raise TypeError("Missing 'consumer_group_password' argument")
        if consumer_group_user_name is None and 'consumerGroupUserName' in kwargs:
            consumer_group_user_name = kwargs['consumerGroupUserName']
        if consumer_group_user_name is None:
            raise TypeError("Missing 'consumer_group_user_name' argument")
        if dts_instance_id is None and 'dtsInstanceId' in kwargs:
            dts_instance_id = kwargs['dtsInstanceId']
        if dts_instance_id is None:
            raise TypeError("Missing 'dts_instance_id' argument")

        _setter("consumer_group_name", consumer_group_name)
        _setter("consumer_group_password", consumer_group_password)
        _setter("consumer_group_user_name", consumer_group_user_name)
        _setter("dts_instance_id", dts_instance_id)

    @property
    @pulumi.getter(name="consumerGroupName")
    def consumer_group_name(self) -> pulumi.Input[str]:
        """
        The name of the consumer group.
        """
        return pulumi.get(self, "consumer_group_name")

    @consumer_group_name.setter
    def consumer_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "consumer_group_name", value)

    @property
    @pulumi.getter(name="consumerGroupPassword")
    def consumer_group_password(self) -> pulumi.Input[str]:
        """
        The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        """
        return pulumi.get(self, "consumer_group_password")

    @consumer_group_password.setter
    def consumer_group_password(self, value: pulumi.Input[str]):
        pulumi.set(self, "consumer_group_password", value)

    @property
    @pulumi.getter(name="consumerGroupUserName")
    def consumer_group_user_name(self) -> pulumi.Input[str]:
        """
        The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        """
        return pulumi.get(self, "consumer_group_user_name")

    @consumer_group_user_name.setter
    def consumer_group_user_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "consumer_group_user_name", value)

    @property
    @pulumi.getter(name="dtsInstanceId")
    def dts_instance_id(self) -> pulumi.Input[str]:
        """
        The ID of the subscription instance.
        """
        return pulumi.get(self, "dts_instance_id")

    @dts_instance_id.setter
    def dts_instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "dts_instance_id", value)


@pulumi.input_type
class _ConsumerChannelState:
    def __init__(__self__, *,
                 consumer_group_id: Optional[pulumi.Input[str]] = None,
                 consumer_group_name: Optional[pulumi.Input[str]] = None,
                 consumer_group_password: Optional[pulumi.Input[str]] = None,
                 consumer_group_user_name: Optional[pulumi.Input[str]] = None,
                 dts_instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ConsumerChannel resources.
        :param pulumi.Input[str] consumer_group_id: The ID of the consumer group.
        :param pulumi.Input[str] consumer_group_name: The name of the consumer group.
        :param pulumi.Input[str] consumer_group_password: The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        :param pulumi.Input[str] consumer_group_user_name: The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        :param pulumi.Input[str] dts_instance_id: The ID of the subscription instance.
        """
        _ConsumerChannelState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            consumer_group_id=consumer_group_id,
            consumer_group_name=consumer_group_name,
            consumer_group_password=consumer_group_password,
            consumer_group_user_name=consumer_group_user_name,
            dts_instance_id=dts_instance_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             consumer_group_id: Optional[pulumi.Input[str]] = None,
             consumer_group_name: Optional[pulumi.Input[str]] = None,
             consumer_group_password: Optional[pulumi.Input[str]] = None,
             consumer_group_user_name: Optional[pulumi.Input[str]] = None,
             dts_instance_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if consumer_group_id is None and 'consumerGroupId' in kwargs:
            consumer_group_id = kwargs['consumerGroupId']
        if consumer_group_name is None and 'consumerGroupName' in kwargs:
            consumer_group_name = kwargs['consumerGroupName']
        if consumer_group_password is None and 'consumerGroupPassword' in kwargs:
            consumer_group_password = kwargs['consumerGroupPassword']
        if consumer_group_user_name is None and 'consumerGroupUserName' in kwargs:
            consumer_group_user_name = kwargs['consumerGroupUserName']
        if dts_instance_id is None and 'dtsInstanceId' in kwargs:
            dts_instance_id = kwargs['dtsInstanceId']

        if consumer_group_id is not None:
            _setter("consumer_group_id", consumer_group_id)
        if consumer_group_name is not None:
            _setter("consumer_group_name", consumer_group_name)
        if consumer_group_password is not None:
            _setter("consumer_group_password", consumer_group_password)
        if consumer_group_user_name is not None:
            _setter("consumer_group_user_name", consumer_group_user_name)
        if dts_instance_id is not None:
            _setter("dts_instance_id", dts_instance_id)

    @property
    @pulumi.getter(name="consumerGroupId")
    def consumer_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the consumer group.
        """
        return pulumi.get(self, "consumer_group_id")

    @consumer_group_id.setter
    def consumer_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "consumer_group_id", value)

    @property
    @pulumi.getter(name="consumerGroupName")
    def consumer_group_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the consumer group.
        """
        return pulumi.get(self, "consumer_group_name")

    @consumer_group_name.setter
    def consumer_group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "consumer_group_name", value)

    @property
    @pulumi.getter(name="consumerGroupPassword")
    def consumer_group_password(self) -> Optional[pulumi.Input[str]]:
        """
        The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        """
        return pulumi.get(self, "consumer_group_password")

    @consumer_group_password.setter
    def consumer_group_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "consumer_group_password", value)

    @property
    @pulumi.getter(name="consumerGroupUserName")
    def consumer_group_user_name(self) -> Optional[pulumi.Input[str]]:
        """
        The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        """
        return pulumi.get(self, "consumer_group_user_name")

    @consumer_group_user_name.setter
    def consumer_group_user_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "consumer_group_user_name", value)

    @property
    @pulumi.getter(name="dtsInstanceId")
    def dts_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the subscription instance.
        """
        return pulumi.get(self, "dts_instance_id")

    @dts_instance_id.setter
    def dts_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dts_instance_id", value)


class ConsumerChannel(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 consumer_group_name: Optional[pulumi.Input[str]] = None,
                 consumer_group_password: Optional[pulumi.Input[str]] = None,
                 consumer_group_user_name: Optional[pulumi.Input[str]] = None,
                 dts_instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a DTS Consumer Channel resource.

        For information about DTS Consumer Channel and how to use it, see [What is Consumer Channel](https://www.alibabacloud.com/help/en/doc-detail/264593.htm).

        > **NOTE:** Available since v1.146.0.

        ## Import

        DTS Consumer Channel can be imported using the id, e.g.

        ```sh
         $ pulumi import alicloud:dts/consumerChannel:ConsumerChannel example <dts_instance_id>:<consumer_group_id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] consumer_group_name: The name of the consumer group.
        :param pulumi.Input[str] consumer_group_password: The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        :param pulumi.Input[str] consumer_group_user_name: The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        :param pulumi.Input[str] dts_instance_id: The ID of the subscription instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConsumerChannelArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a DTS Consumer Channel resource.

        For information about DTS Consumer Channel and how to use it, see [What is Consumer Channel](https://www.alibabacloud.com/help/en/doc-detail/264593.htm).

        > **NOTE:** Available since v1.146.0.

        ## Import

        DTS Consumer Channel can be imported using the id, e.g.

        ```sh
         $ pulumi import alicloud:dts/consumerChannel:ConsumerChannel example <dts_instance_id>:<consumer_group_id>
        ```

        :param str resource_name: The name of the resource.
        :param ConsumerChannelArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConsumerChannelArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            ConsumerChannelArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 consumer_group_name: Optional[pulumi.Input[str]] = None,
                 consumer_group_password: Optional[pulumi.Input[str]] = None,
                 consumer_group_user_name: Optional[pulumi.Input[str]] = None,
                 dts_instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConsumerChannelArgs.__new__(ConsumerChannelArgs)

            if consumer_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'consumer_group_name'")
            __props__.__dict__["consumer_group_name"] = consumer_group_name
            if consumer_group_password is None and not opts.urn:
                raise TypeError("Missing required property 'consumer_group_password'")
            __props__.__dict__["consumer_group_password"] = consumer_group_password
            if consumer_group_user_name is None and not opts.urn:
                raise TypeError("Missing required property 'consumer_group_user_name'")
            __props__.__dict__["consumer_group_user_name"] = consumer_group_user_name
            if dts_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'dts_instance_id'")
            __props__.__dict__["dts_instance_id"] = dts_instance_id
            __props__.__dict__["consumer_group_id"] = None
        super(ConsumerChannel, __self__).__init__(
            'alicloud:dts/consumerChannel:ConsumerChannel',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            consumer_group_id: Optional[pulumi.Input[str]] = None,
            consumer_group_name: Optional[pulumi.Input[str]] = None,
            consumer_group_password: Optional[pulumi.Input[str]] = None,
            consumer_group_user_name: Optional[pulumi.Input[str]] = None,
            dts_instance_id: Optional[pulumi.Input[str]] = None) -> 'ConsumerChannel':
        """
        Get an existing ConsumerChannel resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] consumer_group_id: The ID of the consumer group.
        :param pulumi.Input[str] consumer_group_name: The name of the consumer group.
        :param pulumi.Input[str] consumer_group_password: The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        :param pulumi.Input[str] consumer_group_user_name: The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        :param pulumi.Input[str] dts_instance_id: The ID of the subscription instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConsumerChannelState.__new__(_ConsumerChannelState)

        __props__.__dict__["consumer_group_id"] = consumer_group_id
        __props__.__dict__["consumer_group_name"] = consumer_group_name
        __props__.__dict__["consumer_group_password"] = consumer_group_password
        __props__.__dict__["consumer_group_user_name"] = consumer_group_user_name
        __props__.__dict__["dts_instance_id"] = dts_instance_id
        return ConsumerChannel(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="consumerGroupId")
    def consumer_group_id(self) -> pulumi.Output[str]:
        """
        The ID of the consumer group.
        """
        return pulumi.get(self, "consumer_group_id")

    @property
    @pulumi.getter(name="consumerGroupName")
    def consumer_group_name(self) -> pulumi.Output[str]:
        """
        The name of the consumer group.
        """
        return pulumi.get(self, "consumer_group_name")

    @property
    @pulumi.getter(name="consumerGroupPassword")
    def consumer_group_password(self) -> pulumi.Output[str]:
        """
        The password of the consumer group account. The length of the `consumer_group_password` is limited to `8` to `32` characters. It can contain two or more of the following characters: uppercase letters, lowercase letters, digits, and special characters.
        """
        return pulumi.get(self, "consumer_group_password")

    @property
    @pulumi.getter(name="consumerGroupUserName")
    def consumer_group_user_name(self) -> pulumi.Output[str]:
        """
        The username of the consumer group. The length of the `consumer_group_user_name` is limited to `1` to `16` characters. It can contain one or more of the following characters: uppercase letters, lowercase letters, digits, and underscores (_).
        """
        return pulumi.get(self, "consumer_group_user_name")

    @property
    @pulumi.getter(name="dtsInstanceId")
    def dts_instance_id(self) -> pulumi.Output[str]:
        """
        The ID of the subscription instance.
        """
        return pulumi.get(self, "dts_instance_id")

