# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'DbInstancePlanPlanConfig',
    'DbInstancePlanPlanConfigPause',
    'DbInstancePlanPlanConfigResume',
    'DbInstancePlanPlanConfigScaleIn',
    'DbInstancePlanPlanConfigScaleOut',
    'InstanceIpWhitelist',
    'GetAccountsAccountResult',
    'GetDbInstancePlansPlanResult',
    'GetDbInstancePlansPlanPlanConfigResult',
    'GetDbInstancePlansPlanPlanConfigPauseResult',
    'GetDbInstancePlansPlanPlanConfigResumeResult',
    'GetDbInstancePlansPlanPlanConfigScaleInResult',
    'GetDbInstancePlansPlanPlanConfigScaleOutResult',
    'GetInstancesInstanceResult',
    'GetInstancesInstanceIpWhitelistResult',
    'GetZonesZoneResult',
]

@pulumi.output_type
class DbInstancePlanPlanConfig(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "scaleIn":
            suggest = "scale_in"
        elif key == "scaleOut":
            suggest = "scale_out"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DbInstancePlanPlanConfig. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DbInstancePlanPlanConfig.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DbInstancePlanPlanConfig.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 pause: Optional['outputs.DbInstancePlanPlanConfigPause'] = None,
                 resume: Optional['outputs.DbInstancePlanPlanConfigResume'] = None,
                 scale_in: Optional['outputs.DbInstancePlanPlanConfigScaleIn'] = None,
                 scale_out: Optional['outputs.DbInstancePlanPlanConfigScaleOut'] = None):
        """
        :param 'DbInstancePlanPlanConfigPauseArgs' pause: Pause instance plan config. See `pause` below.
        :param 'DbInstancePlanPlanConfigResumeArgs' resume: Resume instance plan config. See `resume` below.
        :param 'DbInstancePlanPlanConfigScaleInArgs' scale_in: Scale In instance plan config. See `scale_in` below.
        :param 'DbInstancePlanPlanConfigScaleOutArgs' scale_out: Scale out instance plan config. See `scale_out` below.
        """
        DbInstancePlanPlanConfig._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            pause=pause,
            resume=resume,
            scale_in=scale_in,
            scale_out=scale_out,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             pause: Optional['outputs.DbInstancePlanPlanConfigPause'] = None,
             resume: Optional['outputs.DbInstancePlanPlanConfigResume'] = None,
             scale_in: Optional['outputs.DbInstancePlanPlanConfigScaleIn'] = None,
             scale_out: Optional['outputs.DbInstancePlanPlanConfigScaleOut'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if scale_in is None and 'scaleIn' in kwargs:
            scale_in = kwargs['scaleIn']
        if scale_out is None and 'scaleOut' in kwargs:
            scale_out = kwargs['scaleOut']

        if pause is not None:
            _setter("pause", pause)
        if resume is not None:
            _setter("resume", resume)
        if scale_in is not None:
            _setter("scale_in", scale_in)
        if scale_out is not None:
            _setter("scale_out", scale_out)

    @property
    @pulumi.getter
    def pause(self) -> Optional['outputs.DbInstancePlanPlanConfigPause']:
        """
        Pause instance plan config. See `pause` below.
        """
        return pulumi.get(self, "pause")

    @property
    @pulumi.getter
    def resume(self) -> Optional['outputs.DbInstancePlanPlanConfigResume']:
        """
        Resume instance plan config. See `resume` below.
        """
        return pulumi.get(self, "resume")

    @property
    @pulumi.getter(name="scaleIn")
    def scale_in(self) -> Optional['outputs.DbInstancePlanPlanConfigScaleIn']:
        """
        Scale In instance plan config. See `scale_in` below.
        """
        return pulumi.get(self, "scale_in")

    @property
    @pulumi.getter(name="scaleOut")
    def scale_out(self) -> Optional['outputs.DbInstancePlanPlanConfigScaleOut']:
        """
        Scale out instance plan config. See `scale_out` below.
        """
        return pulumi.get(self, "scale_out")


@pulumi.output_type
class DbInstancePlanPlanConfigPause(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "executeTime":
            suggest = "execute_time"
        elif key == "planCronTime":
            suggest = "plan_cron_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DbInstancePlanPlanConfigPause. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DbInstancePlanPlanConfigPause.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DbInstancePlanPlanConfigPause.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 execute_time: Optional[str] = None,
                 plan_cron_time: Optional[str] = None):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        """
        DbInstancePlanPlanConfigPause._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']

        if execute_time is not None:
            _setter("execute_time", execute_time)
        if plan_cron_time is not None:
            _setter("plan_cron_time", plan_cron_time)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> Optional[str]:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> Optional[str]:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")


@pulumi.output_type
class DbInstancePlanPlanConfigResume(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "executeTime":
            suggest = "execute_time"
        elif key == "planCronTime":
            suggest = "plan_cron_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DbInstancePlanPlanConfigResume. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DbInstancePlanPlanConfigResume.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DbInstancePlanPlanConfigResume.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 execute_time: Optional[str] = None,
                 plan_cron_time: Optional[str] = None):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        """
        DbInstancePlanPlanConfigResume._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']

        if execute_time is not None:
            _setter("execute_time", execute_time)
        if plan_cron_time is not None:
            _setter("plan_cron_time", plan_cron_time)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> Optional[str]:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> Optional[str]:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")


@pulumi.output_type
class DbInstancePlanPlanConfigScaleIn(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "executeTime":
            suggest = "execute_time"
        elif key == "planCronTime":
            suggest = "plan_cron_time"
        elif key == "segmentNodeNum":
            suggest = "segment_node_num"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DbInstancePlanPlanConfigScaleIn. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DbInstancePlanPlanConfigScaleIn.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DbInstancePlanPlanConfigScaleIn.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 execute_time: Optional[str] = None,
                 plan_cron_time: Optional[str] = None,
                 segment_node_num: Optional[str] = None):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str segment_node_num: The segment Node Num of the Plan.
        """
        DbInstancePlanPlanConfigScaleIn._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            segment_node_num=segment_node_num,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             segment_node_num: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if segment_node_num is None and 'segmentNodeNum' in kwargs:
            segment_node_num = kwargs['segmentNodeNum']

        if execute_time is not None:
            _setter("execute_time", execute_time)
        if plan_cron_time is not None:
            _setter("plan_cron_time", plan_cron_time)
        if segment_node_num is not None:
            _setter("segment_node_num", segment_node_num)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> Optional[str]:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> Optional[str]:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="segmentNodeNum")
    def segment_node_num(self) -> Optional[str]:
        """
        The segment Node Num of the Plan.
        """
        return pulumi.get(self, "segment_node_num")


@pulumi.output_type
class DbInstancePlanPlanConfigScaleOut(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "executeTime":
            suggest = "execute_time"
        elif key == "planCronTime":
            suggest = "plan_cron_time"
        elif key == "segmentNodeNum":
            suggest = "segment_node_num"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DbInstancePlanPlanConfigScaleOut. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DbInstancePlanPlanConfigScaleOut.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DbInstancePlanPlanConfigScaleOut.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 execute_time: Optional[str] = None,
                 plan_cron_time: Optional[str] = None,
                 segment_node_num: Optional[str] = None):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str segment_node_num: The segment Node Num of the Plan.
        """
        DbInstancePlanPlanConfigScaleOut._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            segment_node_num=segment_node_num,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             segment_node_num: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if segment_node_num is None and 'segmentNodeNum' in kwargs:
            segment_node_num = kwargs['segmentNodeNum']

        if execute_time is not None:
            _setter("execute_time", execute_time)
        if plan_cron_time is not None:
            _setter("plan_cron_time", plan_cron_time)
        if segment_node_num is not None:
            _setter("segment_node_num", segment_node_num)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> Optional[str]:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> Optional[str]:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="segmentNodeNum")
    def segment_node_num(self) -> Optional[str]:
        """
        The segment Node Num of the Plan.
        """
        return pulumi.get(self, "segment_node_num")


@pulumi.output_type
class InstanceIpWhitelist(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipGroupAttribute":
            suggest = "ip_group_attribute"
        elif key == "ipGroupName":
            suggest = "ip_group_name"
        elif key == "securityIpList":
            suggest = "security_ip_list"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in InstanceIpWhitelist. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        InstanceIpWhitelist.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        InstanceIpWhitelist.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_group_attribute: Optional[str] = None,
                 ip_group_name: Optional[str] = None,
                 security_ip_list: Optional[str] = None):
        """
        :param str ip_group_attribute: The value of this parameter is empty by default. The attribute of the whitelist group. 
               If the value contains `hidden`, this white list item will not output.
        :param str ip_group_name: IP whitelist group name.
        :param str security_ip_list: List of IP addresses allowed to access all databases of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32]). System default to `["127.0.0.1"]`.
        """
        InstanceIpWhitelist._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ip_group_attribute=ip_group_attribute,
            ip_group_name=ip_group_name,
            security_ip_list=security_ip_list,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ip_group_attribute: Optional[str] = None,
             ip_group_name: Optional[str] = None,
             security_ip_list: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ip_group_attribute is None and 'ipGroupAttribute' in kwargs:
            ip_group_attribute = kwargs['ipGroupAttribute']
        if ip_group_name is None and 'ipGroupName' in kwargs:
            ip_group_name = kwargs['ipGroupName']
        if security_ip_list is None and 'securityIpList' in kwargs:
            security_ip_list = kwargs['securityIpList']

        if ip_group_attribute is not None:
            _setter("ip_group_attribute", ip_group_attribute)
        if ip_group_name is not None:
            _setter("ip_group_name", ip_group_name)
        if security_ip_list is not None:
            _setter("security_ip_list", security_ip_list)

    @property
    @pulumi.getter(name="ipGroupAttribute")
    def ip_group_attribute(self) -> Optional[str]:
        """
        The value of this parameter is empty by default. The attribute of the whitelist group. 
        If the value contains `hidden`, this white list item will not output.
        """
        return pulumi.get(self, "ip_group_attribute")

    @property
    @pulumi.getter(name="ipGroupName")
    def ip_group_name(self) -> Optional[str]:
        """
        IP whitelist group name.
        """
        return pulumi.get(self, "ip_group_name")

    @property
    @pulumi.getter(name="securityIpList")
    def security_ip_list(self) -> Optional[str]:
        """
        List of IP addresses allowed to access all databases of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32]). System default to `["127.0.0.1"]`.
        """
        return pulumi.get(self, "security_ip_list")


@pulumi.output_type
class GetAccountsAccountResult(dict):
    def __init__(__self__, *,
                 account_description: str,
                 account_name: str,
                 db_instance_id: str,
                 id: str,
                 status: str):
        """
        :param str account_description: The description of the account.
        :param str account_name: The name of the account.
        :param str db_instance_id: The ID of the instance.
        :param str id: The ID of the Account. Its value is same as Queue Name.
        :param str status: The status of the account. Valid values: `Active`, `Creating` and `Deleting`.
        """
        GetAccountsAccountResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            account_description=account_description,
            account_name=account_name,
            db_instance_id=db_instance_id,
            id=id,
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             account_description: Optional[str] = None,
             account_name: Optional[str] = None,
             db_instance_id: Optional[str] = None,
             id: Optional[str] = None,
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if account_description is None and 'accountDescription' in kwargs:
            account_description = kwargs['accountDescription']
        if account_description is None:
            raise TypeError("Missing 'account_description' argument")
        if account_name is None and 'accountName' in kwargs:
            account_name = kwargs['accountName']
        if account_name is None:
            raise TypeError("Missing 'account_name' argument")
        if db_instance_id is None and 'dbInstanceId' in kwargs:
            db_instance_id = kwargs['dbInstanceId']
        if db_instance_id is None:
            raise TypeError("Missing 'db_instance_id' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if status is None:
            raise TypeError("Missing 'status' argument")

        _setter("account_description", account_description)
        _setter("account_name", account_name)
        _setter("db_instance_id", db_instance_id)
        _setter("id", id)
        _setter("status", status)

    @property
    @pulumi.getter(name="accountDescription")
    def account_description(self) -> str:
        """
        The description of the account.
        """
        return pulumi.get(self, "account_description")

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> str:
        """
        The name of the account.
        """
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> str:
        """
        The ID of the instance.
        """
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Account. Its value is same as Queue Name.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of the account. Valid values: `Active`, `Creating` and `Deleting`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class GetDbInstancePlansPlanResult(dict):
    def __init__(__self__, *,
                 db_instance_plan_name: str,
                 id: str,
                 plan_configs: Sequence['outputs.GetDbInstancePlansPlanPlanConfigResult'],
                 plan_desc: str,
                 plan_end_date: str,
                 plan_id: str,
                 plan_schedule_type: str,
                 plan_start_date: str,
                 plan_type: str,
                 status: str):
        """
        :param str db_instance_plan_name: The name of the Plan.
        :param str id: The ID of the resource. The value formats as `<db_instance_id>:<plan_id>`.
        :param Sequence['GetDbInstancePlansPlanPlanConfigArgs'] plan_configs: Plan configuration information.
        :param str plan_end_date: The end time of the Plan.
        :param str plan_id: The ID of DB Instance Plan.
        :param str plan_schedule_type: Plan scheduling type. Valid values: `Postpone`, `Regular`.
        :param str plan_start_date: The start time of the Plan.
        :param str plan_type: The type of the Plan. Valid values: `PauseResume`, `Resize`.
        :param str status: The Status of the Plan.
        """
        GetDbInstancePlansPlanResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            db_instance_plan_name=db_instance_plan_name,
            id=id,
            plan_configs=plan_configs,
            plan_desc=plan_desc,
            plan_end_date=plan_end_date,
            plan_id=plan_id,
            plan_schedule_type=plan_schedule_type,
            plan_start_date=plan_start_date,
            plan_type=plan_type,
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             db_instance_plan_name: Optional[str] = None,
             id: Optional[str] = None,
             plan_configs: Optional[Sequence['outputs.GetDbInstancePlansPlanPlanConfigResult']] = None,
             plan_desc: Optional[str] = None,
             plan_end_date: Optional[str] = None,
             plan_id: Optional[str] = None,
             plan_schedule_type: Optional[str] = None,
             plan_start_date: Optional[str] = None,
             plan_type: Optional[str] = None,
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if db_instance_plan_name is None and 'dbInstancePlanName' in kwargs:
            db_instance_plan_name = kwargs['dbInstancePlanName']
        if db_instance_plan_name is None:
            raise TypeError("Missing 'db_instance_plan_name' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if plan_configs is None and 'planConfigs' in kwargs:
            plan_configs = kwargs['planConfigs']
        if plan_configs is None:
            raise TypeError("Missing 'plan_configs' argument")
        if plan_desc is None and 'planDesc' in kwargs:
            plan_desc = kwargs['planDesc']
        if plan_desc is None:
            raise TypeError("Missing 'plan_desc' argument")
        if plan_end_date is None and 'planEndDate' in kwargs:
            plan_end_date = kwargs['planEndDate']
        if plan_end_date is None:
            raise TypeError("Missing 'plan_end_date' argument")
        if plan_id is None and 'planId' in kwargs:
            plan_id = kwargs['planId']
        if plan_id is None:
            raise TypeError("Missing 'plan_id' argument")
        if plan_schedule_type is None and 'planScheduleType' in kwargs:
            plan_schedule_type = kwargs['planScheduleType']
        if plan_schedule_type is None:
            raise TypeError("Missing 'plan_schedule_type' argument")
        if plan_start_date is None and 'planStartDate' in kwargs:
            plan_start_date = kwargs['planStartDate']
        if plan_start_date is None:
            raise TypeError("Missing 'plan_start_date' argument")
        if plan_type is None and 'planType' in kwargs:
            plan_type = kwargs['planType']
        if plan_type is None:
            raise TypeError("Missing 'plan_type' argument")
        if status is None:
            raise TypeError("Missing 'status' argument")

        _setter("db_instance_plan_name", db_instance_plan_name)
        _setter("id", id)
        _setter("plan_configs", plan_configs)
        _setter("plan_desc", plan_desc)
        _setter("plan_end_date", plan_end_date)
        _setter("plan_id", plan_id)
        _setter("plan_schedule_type", plan_schedule_type)
        _setter("plan_start_date", plan_start_date)
        _setter("plan_type", plan_type)
        _setter("status", status)

    @property
    @pulumi.getter(name="dbInstancePlanName")
    def db_instance_plan_name(self) -> str:
        """
        The name of the Plan.
        """
        return pulumi.get(self, "db_instance_plan_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the resource. The value formats as `<db_instance_id>:<plan_id>`.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="planConfigs")
    def plan_configs(self) -> Sequence['outputs.GetDbInstancePlansPlanPlanConfigResult']:
        """
        Plan configuration information.
        """
        return pulumi.get(self, "plan_configs")

    @property
    @pulumi.getter(name="planDesc")
    def plan_desc(self) -> str:
        return pulumi.get(self, "plan_desc")

    @property
    @pulumi.getter(name="planEndDate")
    def plan_end_date(self) -> str:
        """
        The end time of the Plan.
        """
        return pulumi.get(self, "plan_end_date")

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> str:
        """
        The ID of DB Instance Plan.
        """
        return pulumi.get(self, "plan_id")

    @property
    @pulumi.getter(name="planScheduleType")
    def plan_schedule_type(self) -> str:
        """
        Plan scheduling type. Valid values: `Postpone`, `Regular`.
        """
        return pulumi.get(self, "plan_schedule_type")

    @property
    @pulumi.getter(name="planStartDate")
    def plan_start_date(self) -> str:
        """
        The start time of the Plan.
        """
        return pulumi.get(self, "plan_start_date")

    @property
    @pulumi.getter(name="planType")
    def plan_type(self) -> str:
        """
        The type of the Plan. Valid values: `PauseResume`, `Resize`.
        """
        return pulumi.get(self, "plan_type")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The Status of the Plan.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class GetDbInstancePlansPlanPlanConfigResult(dict):
    def __init__(__self__, *,
                 pauses: Sequence['outputs.GetDbInstancePlansPlanPlanConfigPauseResult'],
                 resumes: Sequence['outputs.GetDbInstancePlansPlanPlanConfigResumeResult'],
                 scale_ins: Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleInResult'],
                 scale_outs: Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleOutResult']):
        """
        :param Sequence['GetDbInstancePlansPlanPlanConfigPauseArgs'] pauses: Pause instance plan config.
        :param Sequence['GetDbInstancePlansPlanPlanConfigResumeArgs'] resumes: Resume instance plan config.
        :param Sequence['GetDbInstancePlansPlanPlanConfigScaleInArgs'] scale_ins: Scale In instance plan config.
        :param Sequence['GetDbInstancePlansPlanPlanConfigScaleOutArgs'] scale_outs: Scale out instance plan config.
        """
        GetDbInstancePlansPlanPlanConfigResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            pauses=pauses,
            resumes=resumes,
            scale_ins=scale_ins,
            scale_outs=scale_outs,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             pauses: Optional[Sequence['outputs.GetDbInstancePlansPlanPlanConfigPauseResult']] = None,
             resumes: Optional[Sequence['outputs.GetDbInstancePlansPlanPlanConfigResumeResult']] = None,
             scale_ins: Optional[Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleInResult']] = None,
             scale_outs: Optional[Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleOutResult']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if pauses is None:
            raise TypeError("Missing 'pauses' argument")
        if resumes is None:
            raise TypeError("Missing 'resumes' argument")
        if scale_ins is None and 'scaleIns' in kwargs:
            scale_ins = kwargs['scaleIns']
        if scale_ins is None:
            raise TypeError("Missing 'scale_ins' argument")
        if scale_outs is None and 'scaleOuts' in kwargs:
            scale_outs = kwargs['scaleOuts']
        if scale_outs is None:
            raise TypeError("Missing 'scale_outs' argument")

        _setter("pauses", pauses)
        _setter("resumes", resumes)
        _setter("scale_ins", scale_ins)
        _setter("scale_outs", scale_outs)

    @property
    @pulumi.getter
    def pauses(self) -> Sequence['outputs.GetDbInstancePlansPlanPlanConfigPauseResult']:
        """
        Pause instance plan config.
        """
        return pulumi.get(self, "pauses")

    @property
    @pulumi.getter
    def resumes(self) -> Sequence['outputs.GetDbInstancePlansPlanPlanConfigResumeResult']:
        """
        Resume instance plan config.
        """
        return pulumi.get(self, "resumes")

    @property
    @pulumi.getter(name="scaleIns")
    def scale_ins(self) -> Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleInResult']:
        """
        Scale In instance plan config.
        """
        return pulumi.get(self, "scale_ins")

    @property
    @pulumi.getter(name="scaleOuts")
    def scale_outs(self) -> Sequence['outputs.GetDbInstancePlansPlanPlanConfigScaleOutResult']:
        """
        Scale out instance plan config.
        """
        return pulumi.get(self, "scale_outs")


@pulumi.output_type
class GetDbInstancePlansPlanPlanConfigPauseResult(dict):
    def __init__(__self__, *,
                 execute_time: str,
                 plan_cron_time: str,
                 plan_task_status: str):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str plan_task_status: The Status of the plan Task.
        """
        GetDbInstancePlansPlanPlanConfigPauseResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            plan_task_status=plan_task_status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             plan_task_status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if execute_time is None:
            raise TypeError("Missing 'execute_time' argument")
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if plan_cron_time is None:
            raise TypeError("Missing 'plan_cron_time' argument")
        if plan_task_status is None and 'planTaskStatus' in kwargs:
            plan_task_status = kwargs['planTaskStatus']
        if plan_task_status is None:
            raise TypeError("Missing 'plan_task_status' argument")

        _setter("execute_time", execute_time)
        _setter("plan_cron_time", plan_cron_time)
        _setter("plan_task_status", plan_task_status)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> str:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> str:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="planTaskStatus")
    def plan_task_status(self) -> str:
        """
        The Status of the plan Task.
        """
        return pulumi.get(self, "plan_task_status")


@pulumi.output_type
class GetDbInstancePlansPlanPlanConfigResumeResult(dict):
    def __init__(__self__, *,
                 execute_time: str,
                 plan_cron_time: str,
                 plan_task_status: str):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str plan_task_status: The Status of the plan Task.
        """
        GetDbInstancePlansPlanPlanConfigResumeResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            plan_task_status=plan_task_status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             plan_task_status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if execute_time is None:
            raise TypeError("Missing 'execute_time' argument")
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if plan_cron_time is None:
            raise TypeError("Missing 'plan_cron_time' argument")
        if plan_task_status is None and 'planTaskStatus' in kwargs:
            plan_task_status = kwargs['planTaskStatus']
        if plan_task_status is None:
            raise TypeError("Missing 'plan_task_status' argument")

        _setter("execute_time", execute_time)
        _setter("plan_cron_time", plan_cron_time)
        _setter("plan_task_status", plan_task_status)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> str:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> str:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="planTaskStatus")
    def plan_task_status(self) -> str:
        """
        The Status of the plan Task.
        """
        return pulumi.get(self, "plan_task_status")


@pulumi.output_type
class GetDbInstancePlansPlanPlanConfigScaleInResult(dict):
    def __init__(__self__, *,
                 execute_time: str,
                 plan_cron_time: str,
                 plan_task_status: str,
                 segment_node_num: str):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str plan_task_status: The Status of the plan Task.
        :param str segment_node_num: The segment Node Num of the Plan.
        """
        GetDbInstancePlansPlanPlanConfigScaleInResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            plan_task_status=plan_task_status,
            segment_node_num=segment_node_num,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             plan_task_status: Optional[str] = None,
             segment_node_num: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if execute_time is None:
            raise TypeError("Missing 'execute_time' argument")
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if plan_cron_time is None:
            raise TypeError("Missing 'plan_cron_time' argument")
        if plan_task_status is None and 'planTaskStatus' in kwargs:
            plan_task_status = kwargs['planTaskStatus']
        if plan_task_status is None:
            raise TypeError("Missing 'plan_task_status' argument")
        if segment_node_num is None and 'segmentNodeNum' in kwargs:
            segment_node_num = kwargs['segmentNodeNum']
        if segment_node_num is None:
            raise TypeError("Missing 'segment_node_num' argument")

        _setter("execute_time", execute_time)
        _setter("plan_cron_time", plan_cron_time)
        _setter("plan_task_status", plan_task_status)
        _setter("segment_node_num", segment_node_num)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> str:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> str:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="planTaskStatus")
    def plan_task_status(self) -> str:
        """
        The Status of the plan Task.
        """
        return pulumi.get(self, "plan_task_status")

    @property
    @pulumi.getter(name="segmentNodeNum")
    def segment_node_num(self) -> str:
        """
        The segment Node Num of the Plan.
        """
        return pulumi.get(self, "segment_node_num")


@pulumi.output_type
class GetDbInstancePlansPlanPlanConfigScaleOutResult(dict):
    def __init__(__self__, *,
                 execute_time: str,
                 plan_cron_time: str,
                 plan_task_status: str,
                 segment_node_num: str):
        """
        :param str execute_time: The executed time of the Plan.
        :param str plan_cron_time: The Cron Time of the plan.
        :param str plan_task_status: The Status of the plan Task.
        :param str segment_node_num: The segment Node Num of the Plan.
        """
        GetDbInstancePlansPlanPlanConfigScaleOutResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            execute_time=execute_time,
            plan_cron_time=plan_cron_time,
            plan_task_status=plan_task_status,
            segment_node_num=segment_node_num,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             execute_time: Optional[str] = None,
             plan_cron_time: Optional[str] = None,
             plan_task_status: Optional[str] = None,
             segment_node_num: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if execute_time is None and 'executeTime' in kwargs:
            execute_time = kwargs['executeTime']
        if execute_time is None:
            raise TypeError("Missing 'execute_time' argument")
        if plan_cron_time is None and 'planCronTime' in kwargs:
            plan_cron_time = kwargs['planCronTime']
        if plan_cron_time is None:
            raise TypeError("Missing 'plan_cron_time' argument")
        if plan_task_status is None and 'planTaskStatus' in kwargs:
            plan_task_status = kwargs['planTaskStatus']
        if plan_task_status is None:
            raise TypeError("Missing 'plan_task_status' argument")
        if segment_node_num is None and 'segmentNodeNum' in kwargs:
            segment_node_num = kwargs['segmentNodeNum']
        if segment_node_num is None:
            raise TypeError("Missing 'segment_node_num' argument")

        _setter("execute_time", execute_time)
        _setter("plan_cron_time", plan_cron_time)
        _setter("plan_task_status", plan_task_status)
        _setter("segment_node_num", segment_node_num)

    @property
    @pulumi.getter(name="executeTime")
    def execute_time(self) -> str:
        """
        The executed time of the Plan.
        """
        return pulumi.get(self, "execute_time")

    @property
    @pulumi.getter(name="planCronTime")
    def plan_cron_time(self) -> str:
        """
        The Cron Time of the plan.
        """
        return pulumi.get(self, "plan_cron_time")

    @property
    @pulumi.getter(name="planTaskStatus")
    def plan_task_status(self) -> str:
        """
        The Status of the plan Task.
        """
        return pulumi.get(self, "plan_task_status")

    @property
    @pulumi.getter(name="segmentNodeNum")
    def segment_node_num(self) -> str:
        """
        The segment Node Num of the Plan.
        """
        return pulumi.get(self, "segment_node_num")


@pulumi.output_type
class GetInstancesInstanceResult(dict):
    def __init__(__self__, *,
                 availability_zone: str,
                 charge_type: str,
                 connection_string: str,
                 cpu_cores: str,
                 create_time: str,
                 creation_time: str,
                 db_instance_category: str,
                 db_instance_class: str,
                 db_instance_id: str,
                 db_instance_mode: str,
                 description: str,
                 engine: str,
                 engine_version: str,
                 id: str,
                 instance_network_type: str,
                 ip_whitelists: Sequence['outputs.GetInstancesInstanceIpWhitelistResult'],
                 maintain_end_time: str,
                 maintain_start_time: str,
                 master_node_num: str,
                 memory_size: str,
                 payment_type: str,
                 region_id: str,
                 seg_node_num: str,
                 status: str,
                 storage_size: int,
                 storage_type: str,
                 tags: Mapping[str, Any],
                 vpc_id: str,
                 vswitch_id: str,
                 zone_id: str):
        """
        :param str availability_zone: Instance availability zone.
        :param str connection_string: The connection string of the instance.
        :param str cpu_cores: The number of CPU cores of the computing node. Unit: Core.
        :param str create_time: The time when the instance was created. The time is in the YYYY-MM-DDThh:mm:ssZ format, such as 2011-05-30T12:11:4Z.
        :param str db_instance_category: The db instance category. Valid values: `HighAvailability`, `Basic`.
        :param str db_instance_class: The db instance class.
        :param str db_instance_id: The db instance id.
        :param str db_instance_mode: The db instance mode. Valid values: `StorageElastic`, `Serverless`, `Classic`.
        :param str description: The description of the instance.
        :param str engine: The database engine used by the instance.
        :param str engine_version: The version of the database engine used by the instance.
        :param str id: The ID of the db Instance.
        :param str instance_network_type: The network type of the instance.
        :param Sequence['GetInstancesInstanceIpWhitelistArgs'] ip_whitelists: The ip whitelist.
        :param str maintain_end_time: The end time of the maintenance window for the instance.
        :param str maintain_start_time: The start time of the maintenance window for the instance.
        :param str master_node_num: The number of Master nodes. Valid values: 1 to 2. if it is not filled in, the default value is 1 Master node.
        :param str memory_size: The memory size of the compute node.
        :param str payment_type: The billing method of the instance. Valid values: `Subscription`, `PayAsYouGo`.
        :param str region_id: Region ID the instance belongs to.
        :param str seg_node_num: Calculate the number of nodes. The value range of the high-availability version of the storage elastic mode is 4 to 512, and the value must be a multiple of 4. The value range of the basic version of the storage elastic mode is 2 to 512, and the value must be a multiple of 2. The-Serverless version has a value range of 2 to 512. The value must be a multiple of 2.
        :param str status: The status of the instance. Valid values: `Creating`, `DBInstanceClassChanging`, `DBInstanceNetTypeChanging`, `Deleting`, `EngineVersionUpgrading`, `GuardDBInstanceCreating`, `GuardSwitching`, `Importing`, `ImportingFromOtherInstance`, `Rebooting`, `Restoring`, `Running`, `Transfering`, `TransferingToOtherInstance`.
        :param int storage_size: The storage capacity. Unit: GB. Value: `50` to `4000`.
        :param str storage_type: The type of disks. Valid values: `cloud_essd`, `cloud_efficiency`.
        :param Mapping[str, Any] tags: The tags of the instance.
        :param str vpc_id: The ID of the VPC。.
        :param str vswitch_id: The vswitch id.
        :param str zone_id: The zone ID of the instance.
        """
        GetInstancesInstanceResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_zone=availability_zone,
            charge_type=charge_type,
            connection_string=connection_string,
            cpu_cores=cpu_cores,
            create_time=create_time,
            creation_time=creation_time,
            db_instance_category=db_instance_category,
            db_instance_class=db_instance_class,
            db_instance_id=db_instance_id,
            db_instance_mode=db_instance_mode,
            description=description,
            engine=engine,
            engine_version=engine_version,
            id=id,
            instance_network_type=instance_network_type,
            ip_whitelists=ip_whitelists,
            maintain_end_time=maintain_end_time,
            maintain_start_time=maintain_start_time,
            master_node_num=master_node_num,
            memory_size=memory_size,
            payment_type=payment_type,
            region_id=region_id,
            seg_node_num=seg_node_num,
            status=status,
            storage_size=storage_size,
            storage_type=storage_type,
            tags=tags,
            vpc_id=vpc_id,
            vswitch_id=vswitch_id,
            zone_id=zone_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_zone: Optional[str] = None,
             charge_type: Optional[str] = None,
             connection_string: Optional[str] = None,
             cpu_cores: Optional[str] = None,
             create_time: Optional[str] = None,
             creation_time: Optional[str] = None,
             db_instance_category: Optional[str] = None,
             db_instance_class: Optional[str] = None,
             db_instance_id: Optional[str] = None,
             db_instance_mode: Optional[str] = None,
             description: Optional[str] = None,
             engine: Optional[str] = None,
             engine_version: Optional[str] = None,
             id: Optional[str] = None,
             instance_network_type: Optional[str] = None,
             ip_whitelists: Optional[Sequence['outputs.GetInstancesInstanceIpWhitelistResult']] = None,
             maintain_end_time: Optional[str] = None,
             maintain_start_time: Optional[str] = None,
             master_node_num: Optional[str] = None,
             memory_size: Optional[str] = None,
             payment_type: Optional[str] = None,
             region_id: Optional[str] = None,
             seg_node_num: Optional[str] = None,
             status: Optional[str] = None,
             storage_size: Optional[int] = None,
             storage_type: Optional[str] = None,
             tags: Optional[Mapping[str, Any]] = None,
             vpc_id: Optional[str] = None,
             vswitch_id: Optional[str] = None,
             zone_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_zone is None and 'availabilityZone' in kwargs:
            availability_zone = kwargs['availabilityZone']
        if availability_zone is None:
            raise TypeError("Missing 'availability_zone' argument")
        if charge_type is None and 'chargeType' in kwargs:
            charge_type = kwargs['chargeType']
        if charge_type is None:
            raise TypeError("Missing 'charge_type' argument")
        if connection_string is None and 'connectionString' in kwargs:
            connection_string = kwargs['connectionString']
        if connection_string is None:
            raise TypeError("Missing 'connection_string' argument")
        if cpu_cores is None and 'cpuCores' in kwargs:
            cpu_cores = kwargs['cpuCores']
        if cpu_cores is None:
            raise TypeError("Missing 'cpu_cores' argument")
        if create_time is None and 'createTime' in kwargs:
            create_time = kwargs['createTime']
        if create_time is None:
            raise TypeError("Missing 'create_time' argument")
        if creation_time is None and 'creationTime' in kwargs:
            creation_time = kwargs['creationTime']
        if creation_time is None:
            raise TypeError("Missing 'creation_time' argument")
        if db_instance_category is None and 'dbInstanceCategory' in kwargs:
            db_instance_category = kwargs['dbInstanceCategory']
        if db_instance_category is None:
            raise TypeError("Missing 'db_instance_category' argument")
        if db_instance_class is None and 'dbInstanceClass' in kwargs:
            db_instance_class = kwargs['dbInstanceClass']
        if db_instance_class is None:
            raise TypeError("Missing 'db_instance_class' argument")
        if db_instance_id is None and 'dbInstanceId' in kwargs:
            db_instance_id = kwargs['dbInstanceId']
        if db_instance_id is None:
            raise TypeError("Missing 'db_instance_id' argument")
        if db_instance_mode is None and 'dbInstanceMode' in kwargs:
            db_instance_mode = kwargs['dbInstanceMode']
        if db_instance_mode is None:
            raise TypeError("Missing 'db_instance_mode' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if engine is None:
            raise TypeError("Missing 'engine' argument")
        if engine_version is None and 'engineVersion' in kwargs:
            engine_version = kwargs['engineVersion']
        if engine_version is None:
            raise TypeError("Missing 'engine_version' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if instance_network_type is None and 'instanceNetworkType' in kwargs:
            instance_network_type = kwargs['instanceNetworkType']
        if instance_network_type is None:
            raise TypeError("Missing 'instance_network_type' argument")
        if ip_whitelists is None and 'ipWhitelists' in kwargs:
            ip_whitelists = kwargs['ipWhitelists']
        if ip_whitelists is None:
            raise TypeError("Missing 'ip_whitelists' argument")
        if maintain_end_time is None and 'maintainEndTime' in kwargs:
            maintain_end_time = kwargs['maintainEndTime']
        if maintain_end_time is None:
            raise TypeError("Missing 'maintain_end_time' argument")
        if maintain_start_time is None and 'maintainStartTime' in kwargs:
            maintain_start_time = kwargs['maintainStartTime']
        if maintain_start_time is None:
            raise TypeError("Missing 'maintain_start_time' argument")
        if master_node_num is None and 'masterNodeNum' in kwargs:
            master_node_num = kwargs['masterNodeNum']
        if master_node_num is None:
            raise TypeError("Missing 'master_node_num' argument")
        if memory_size is None and 'memorySize' in kwargs:
            memory_size = kwargs['memorySize']
        if memory_size is None:
            raise TypeError("Missing 'memory_size' argument")
        if payment_type is None and 'paymentType' in kwargs:
            payment_type = kwargs['paymentType']
        if payment_type is None:
            raise TypeError("Missing 'payment_type' argument")
        if region_id is None and 'regionId' in kwargs:
            region_id = kwargs['regionId']
        if region_id is None:
            raise TypeError("Missing 'region_id' argument")
        if seg_node_num is None and 'segNodeNum' in kwargs:
            seg_node_num = kwargs['segNodeNum']
        if seg_node_num is None:
            raise TypeError("Missing 'seg_node_num' argument")
        if status is None:
            raise TypeError("Missing 'status' argument")
        if storage_size is None and 'storageSize' in kwargs:
            storage_size = kwargs['storageSize']
        if storage_size is None:
            raise TypeError("Missing 'storage_size' argument")
        if storage_type is None and 'storageType' in kwargs:
            storage_type = kwargs['storageType']
        if storage_type is None:
            raise TypeError("Missing 'storage_type' argument")
        if tags is None:
            raise TypeError("Missing 'tags' argument")
        if vpc_id is None and 'vpcId' in kwargs:
            vpc_id = kwargs['vpcId']
        if vpc_id is None:
            raise TypeError("Missing 'vpc_id' argument")
        if vswitch_id is None and 'vswitchId' in kwargs:
            vswitch_id = kwargs['vswitchId']
        if vswitch_id is None:
            raise TypeError("Missing 'vswitch_id' argument")
        if zone_id is None and 'zoneId' in kwargs:
            zone_id = kwargs['zoneId']
        if zone_id is None:
            raise TypeError("Missing 'zone_id' argument")

        _setter("availability_zone", availability_zone)
        _setter("charge_type", charge_type)
        _setter("connection_string", connection_string)
        _setter("cpu_cores", cpu_cores)
        _setter("create_time", create_time)
        _setter("creation_time", creation_time)
        _setter("db_instance_category", db_instance_category)
        _setter("db_instance_class", db_instance_class)
        _setter("db_instance_id", db_instance_id)
        _setter("db_instance_mode", db_instance_mode)
        _setter("description", description)
        _setter("engine", engine)
        _setter("engine_version", engine_version)
        _setter("id", id)
        _setter("instance_network_type", instance_network_type)
        _setter("ip_whitelists", ip_whitelists)
        _setter("maintain_end_time", maintain_end_time)
        _setter("maintain_start_time", maintain_start_time)
        _setter("master_node_num", master_node_num)
        _setter("memory_size", memory_size)
        _setter("payment_type", payment_type)
        _setter("region_id", region_id)
        _setter("seg_node_num", seg_node_num)
        _setter("status", status)
        _setter("storage_size", storage_size)
        _setter("storage_type", storage_type)
        _setter("tags", tags)
        _setter("vpc_id", vpc_id)
        _setter("vswitch_id", vswitch_id)
        _setter("zone_id", zone_id)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> str:
        """
        Instance availability zone.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> str:
        return pulumi.get(self, "charge_type")

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> str:
        """
        The connection string of the instance.
        """
        return pulumi.get(self, "connection_string")

    @property
    @pulumi.getter(name="cpuCores")
    def cpu_cores(self) -> str:
        """
        The number of CPU cores of the computing node. Unit: Core.
        """
        return pulumi.get(self, "cpu_cores")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The time when the instance was created. The time is in the YYYY-MM-DDThh:mm:ssZ format, such as 2011-05-30T12:11:4Z.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="creationTime")
    def creation_time(self) -> str:
        return pulumi.get(self, "creation_time")

    @property
    @pulumi.getter(name="dbInstanceCategory")
    def db_instance_category(self) -> str:
        """
        The db instance category. Valid values: `HighAvailability`, `Basic`.
        """
        return pulumi.get(self, "db_instance_category")

    @property
    @pulumi.getter(name="dbInstanceClass")
    def db_instance_class(self) -> str:
        """
        The db instance class.
        """
        return pulumi.get(self, "db_instance_class")

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> str:
        """
        The db instance id.
        """
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter(name="dbInstanceMode")
    def db_instance_mode(self) -> str:
        """
        The db instance mode. Valid values: `StorageElastic`, `Serverless`, `Classic`.
        """
        return pulumi.get(self, "db_instance_mode")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the instance.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def engine(self) -> str:
        """
        The database engine used by the instance.
        """
        return pulumi.get(self, "engine")

    @property
    @pulumi.getter(name="engineVersion")
    def engine_version(self) -> str:
        """
        The version of the database engine used by the instance.
        """
        return pulumi.get(self, "engine_version")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the db Instance.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceNetworkType")
    def instance_network_type(self) -> str:
        """
        The network type of the instance.
        """
        return pulumi.get(self, "instance_network_type")

    @property
    @pulumi.getter(name="ipWhitelists")
    def ip_whitelists(self) -> Sequence['outputs.GetInstancesInstanceIpWhitelistResult']:
        """
        The ip whitelist.
        """
        return pulumi.get(self, "ip_whitelists")

    @property
    @pulumi.getter(name="maintainEndTime")
    def maintain_end_time(self) -> str:
        """
        The end time of the maintenance window for the instance.
        """
        return pulumi.get(self, "maintain_end_time")

    @property
    @pulumi.getter(name="maintainStartTime")
    def maintain_start_time(self) -> str:
        """
        The start time of the maintenance window for the instance.
        """
        return pulumi.get(self, "maintain_start_time")

    @property
    @pulumi.getter(name="masterNodeNum")
    def master_node_num(self) -> str:
        """
        The number of Master nodes. Valid values: 1 to 2. if it is not filled in, the default value is 1 Master node.
        """
        return pulumi.get(self, "master_node_num")

    @property
    @pulumi.getter(name="memorySize")
    def memory_size(self) -> str:
        """
        The memory size of the compute node.
        """
        return pulumi.get(self, "memory_size")

    @property
    @pulumi.getter(name="paymentType")
    def payment_type(self) -> str:
        """
        The billing method of the instance. Valid values: `Subscription`, `PayAsYouGo`.
        """
        return pulumi.get(self, "payment_type")

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        """
        Region ID the instance belongs to.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter(name="segNodeNum")
    def seg_node_num(self) -> str:
        """
        Calculate the number of nodes. The value range of the high-availability version of the storage elastic mode is 4 to 512, and the value must be a multiple of 4. The value range of the basic version of the storage elastic mode is 2 to 512, and the value must be a multiple of 2. The-Serverless version has a value range of 2 to 512. The value must be a multiple of 2.
        """
        return pulumi.get(self, "seg_node_num")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of the instance. Valid values: `Creating`, `DBInstanceClassChanging`, `DBInstanceNetTypeChanging`, `Deleting`, `EngineVersionUpgrading`, `GuardDBInstanceCreating`, `GuardSwitching`, `Importing`, `ImportingFromOtherInstance`, `Rebooting`, `Restoring`, `Running`, `Transfering`, `TransferingToOtherInstance`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> int:
        """
        The storage capacity. Unit: GB. Value: `50` to `4000`.
        """
        return pulumi.get(self, "storage_size")

    @property
    @pulumi.getter(name="storageType")
    def storage_type(self) -> str:
        """
        The type of disks. Valid values: `cloud_essd`, `cloud_efficiency`.
        """
        return pulumi.get(self, "storage_type")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        The tags of the instance.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> str:
        """
        The ID of the VPC。.
        """
        return pulumi.get(self, "vpc_id")

    @property
    @pulumi.getter(name="vswitchId")
    def vswitch_id(self) -> str:
        """
        The vswitch id.
        """
        return pulumi.get(self, "vswitch_id")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> str:
        """
        The zone ID of the instance.
        """
        return pulumi.get(self, "zone_id")


@pulumi.output_type
class GetInstancesInstanceIpWhitelistResult(dict):
    def __init__(__self__, *,
                 ip_group_attribute: str,
                 ip_group_name: str,
                 security_ip_list: str):
        """
        :param str ip_group_attribute: The value of this parameter is empty by default. The attribute of the whitelist group. The console does not display the whitelist group whose value of this parameter is hidden.
        :param str ip_group_name: IP whitelist group name
        :param str security_ip_list: List of IP addresses allowed to access all databases of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32]). System default to `["127.0.0.1"]`.
        """
        GetInstancesInstanceIpWhitelistResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ip_group_attribute=ip_group_attribute,
            ip_group_name=ip_group_name,
            security_ip_list=security_ip_list,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ip_group_attribute: Optional[str] = None,
             ip_group_name: Optional[str] = None,
             security_ip_list: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ip_group_attribute is None and 'ipGroupAttribute' in kwargs:
            ip_group_attribute = kwargs['ipGroupAttribute']
        if ip_group_attribute is None:
            raise TypeError("Missing 'ip_group_attribute' argument")
        if ip_group_name is None and 'ipGroupName' in kwargs:
            ip_group_name = kwargs['ipGroupName']
        if ip_group_name is None:
            raise TypeError("Missing 'ip_group_name' argument")
        if security_ip_list is None and 'securityIpList' in kwargs:
            security_ip_list = kwargs['securityIpList']
        if security_ip_list is None:
            raise TypeError("Missing 'security_ip_list' argument")

        _setter("ip_group_attribute", ip_group_attribute)
        _setter("ip_group_name", ip_group_name)
        _setter("security_ip_list", security_ip_list)

    @property
    @pulumi.getter(name="ipGroupAttribute")
    def ip_group_attribute(self) -> str:
        """
        The value of this parameter is empty by default. The attribute of the whitelist group. The console does not display the whitelist group whose value of this parameter is hidden.
        """
        return pulumi.get(self, "ip_group_attribute")

    @property
    @pulumi.getter(name="ipGroupName")
    def ip_group_name(self) -> str:
        """
        IP whitelist group name
        """
        return pulumi.get(self, "ip_group_name")

    @property
    @pulumi.getter(name="securityIpList")
    def security_ip_list(self) -> str:
        """
        List of IP addresses allowed to access all databases of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32]). System default to `["127.0.0.1"]`.
        """
        return pulumi.get(self, "security_ip_list")


@pulumi.output_type
class GetZonesZoneResult(dict):
    def __init__(__self__, *,
                 id: str,
                 multi_zone_ids: Sequence[str]):
        """
        :param str id: ID of the zone.
        :param Sequence[str] multi_zone_ids: A list of zone ids in which the multi zone.
        """
        GetZonesZoneResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            multi_zone_ids=multi_zone_ids,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             multi_zone_ids: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")
        if multi_zone_ids is None and 'multiZoneIds' in kwargs:
            multi_zone_ids = kwargs['multiZoneIds']
        if multi_zone_ids is None:
            raise TypeError("Missing 'multi_zone_ids' argument")

        _setter("id", id)
        _setter("multi_zone_ids", multi_zone_ids)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        ID of the zone.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="multiZoneIds")
    def multi_zone_ids(self) -> Sequence[str]:
        """
        A list of zone ids in which the multi zone.
        """
        return pulumi.get(self, "multi_zone_ids")


