# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetMscSubContactsContactResult',
    'GetMscSubSubscriptionsSubscriptionResult',
    'GetMscSubWebhooksWebhookResult',
    'GetRegionsRegionResult',
    'GetZonesZoneResult',
]

@pulumi.output_type
class GetMscSubContactsContactResult(dict):
    def __init__(__self__, *,
                 account_uid: str,
                 contact_id: str,
                 contact_name: str,
                 email: str,
                 id: str,
                 is_account: bool,
                 is_obsolete: bool,
                 is_verified_email: bool,
                 is_verified_mobile: bool,
                 last_email_verification_time_stamp: str,
                 last_mobile_verification_time_stamp: str,
                 mobile: str,
                 position: str):
        """
        :param str account_uid: UID.
        :param str contact_id: The first ID of the resource.
        :param str contact_name: The User's Contact Name. **Note:** The name must be 2 to 12 characters in length, and can contain uppercase and lowercase letters.
        :param str email: The User's Contact Email Address.
        :param str id: The ID of the Contact.
        :param bool is_account: Indicates Whether the BGP Group Is the Account Itself.
        :param bool is_obsolete: Whether They Have Expired Or Not.
        :param bool is_verified_email: Email Validation for.
        :param bool is_verified_mobile: If the Phone Verification.
        :param str last_email_verification_time_stamp: Last Verification Email Transmission Time.
        :param str last_mobile_verification_time_stamp: The Pieces of Authentication SMS Sending Time.
        :param str mobile: The User's Telephone.
        :param str position: The User's Position. Valid values: `CEO`, `Technical Director`, `Maintenance Director`, `Project Director`,`Finance Director` and `Other`.
        """
        GetMscSubContactsContactResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            account_uid=account_uid,
            contact_id=contact_id,
            contact_name=contact_name,
            email=email,
            id=id,
            is_account=is_account,
            is_obsolete=is_obsolete,
            is_verified_email=is_verified_email,
            is_verified_mobile=is_verified_mobile,
            last_email_verification_time_stamp=last_email_verification_time_stamp,
            last_mobile_verification_time_stamp=last_mobile_verification_time_stamp,
            mobile=mobile,
            position=position,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             account_uid: Optional[str] = None,
             contact_id: Optional[str] = None,
             contact_name: Optional[str] = None,
             email: Optional[str] = None,
             id: Optional[str] = None,
             is_account: Optional[bool] = None,
             is_obsolete: Optional[bool] = None,
             is_verified_email: Optional[bool] = None,
             is_verified_mobile: Optional[bool] = None,
             last_email_verification_time_stamp: Optional[str] = None,
             last_mobile_verification_time_stamp: Optional[str] = None,
             mobile: Optional[str] = None,
             position: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if account_uid is None and 'accountUid' in kwargs:
            account_uid = kwargs['accountUid']
        if account_uid is None:
            raise TypeError("Missing 'account_uid' argument")
        if contact_id is None and 'contactId' in kwargs:
            contact_id = kwargs['contactId']
        if contact_id is None:
            raise TypeError("Missing 'contact_id' argument")
        if contact_name is None and 'contactName' in kwargs:
            contact_name = kwargs['contactName']
        if contact_name is None:
            raise TypeError("Missing 'contact_name' argument")
        if email is None:
            raise TypeError("Missing 'email' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if is_account is None and 'isAccount' in kwargs:
            is_account = kwargs['isAccount']
        if is_account is None:
            raise TypeError("Missing 'is_account' argument")
        if is_obsolete is None and 'isObsolete' in kwargs:
            is_obsolete = kwargs['isObsolete']
        if is_obsolete is None:
            raise TypeError("Missing 'is_obsolete' argument")
        if is_verified_email is None and 'isVerifiedEmail' in kwargs:
            is_verified_email = kwargs['isVerifiedEmail']
        if is_verified_email is None:
            raise TypeError("Missing 'is_verified_email' argument")
        if is_verified_mobile is None and 'isVerifiedMobile' in kwargs:
            is_verified_mobile = kwargs['isVerifiedMobile']
        if is_verified_mobile is None:
            raise TypeError("Missing 'is_verified_mobile' argument")
        if last_email_verification_time_stamp is None and 'lastEmailVerificationTimeStamp' in kwargs:
            last_email_verification_time_stamp = kwargs['lastEmailVerificationTimeStamp']
        if last_email_verification_time_stamp is None:
            raise TypeError("Missing 'last_email_verification_time_stamp' argument")
        if last_mobile_verification_time_stamp is None and 'lastMobileVerificationTimeStamp' in kwargs:
            last_mobile_verification_time_stamp = kwargs['lastMobileVerificationTimeStamp']
        if last_mobile_verification_time_stamp is None:
            raise TypeError("Missing 'last_mobile_verification_time_stamp' argument")
        if mobile is None:
            raise TypeError("Missing 'mobile' argument")
        if position is None:
            raise TypeError("Missing 'position' argument")

        _setter("account_uid", account_uid)
        _setter("contact_id", contact_id)
        _setter("contact_name", contact_name)
        _setter("email", email)
        _setter("id", id)
        _setter("is_account", is_account)
        _setter("is_obsolete", is_obsolete)
        _setter("is_verified_email", is_verified_email)
        _setter("is_verified_mobile", is_verified_mobile)
        _setter("last_email_verification_time_stamp", last_email_verification_time_stamp)
        _setter("last_mobile_verification_time_stamp", last_mobile_verification_time_stamp)
        _setter("mobile", mobile)
        _setter("position", position)

    @property
    @pulumi.getter(name="accountUid")
    def account_uid(self) -> str:
        """
        UID.
        """
        return pulumi.get(self, "account_uid")

    @property
    @pulumi.getter(name="contactId")
    def contact_id(self) -> str:
        """
        The first ID of the resource.
        """
        return pulumi.get(self, "contact_id")

    @property
    @pulumi.getter(name="contactName")
    def contact_name(self) -> str:
        """
        The User's Contact Name. **Note:** The name must be 2 to 12 characters in length, and can contain uppercase and lowercase letters.
        """
        return pulumi.get(self, "contact_name")

    @property
    @pulumi.getter
    def email(self) -> str:
        """
        The User's Contact Email Address.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Contact.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isAccount")
    def is_account(self) -> bool:
        """
        Indicates Whether the BGP Group Is the Account Itself.
        """
        return pulumi.get(self, "is_account")

    @property
    @pulumi.getter(name="isObsolete")
    def is_obsolete(self) -> bool:
        """
        Whether They Have Expired Or Not.
        """
        return pulumi.get(self, "is_obsolete")

    @property
    @pulumi.getter(name="isVerifiedEmail")
    def is_verified_email(self) -> bool:
        """
        Email Validation for.
        """
        return pulumi.get(self, "is_verified_email")

    @property
    @pulumi.getter(name="isVerifiedMobile")
    def is_verified_mobile(self) -> bool:
        """
        If the Phone Verification.
        """
        return pulumi.get(self, "is_verified_mobile")

    @property
    @pulumi.getter(name="lastEmailVerificationTimeStamp")
    def last_email_verification_time_stamp(self) -> str:
        """
        Last Verification Email Transmission Time.
        """
        return pulumi.get(self, "last_email_verification_time_stamp")

    @property
    @pulumi.getter(name="lastMobileVerificationTimeStamp")
    def last_mobile_verification_time_stamp(self) -> str:
        """
        The Pieces of Authentication SMS Sending Time.
        """
        return pulumi.get(self, "last_mobile_verification_time_stamp")

    @property
    @pulumi.getter
    def mobile(self) -> str:
        """
        The User's Telephone.
        """
        return pulumi.get(self, "mobile")

    @property
    @pulumi.getter
    def position(self) -> str:
        """
        The User's Position. Valid values: `CEO`, `Technical Director`, `Maintenance Director`, `Project Director`,`Finance Director` and `Other`.
        """
        return pulumi.get(self, "position")


@pulumi.output_type
class GetMscSubSubscriptionsSubscriptionResult(dict):
    def __init__(__self__, *,
                 channel: str,
                 contact_ids: Sequence[int],
                 description: str,
                 email_status: int,
                 id: str,
                 item_id: str,
                 item_name: str,
                 pmsg_status: int,
                 sms_status: int,
                 tts_status: int,
                 webhook_ids: Sequence[int],
                 webhook_status: int):
        """
        :param str channel: The channel the Subscription.
        :param Sequence[int] contact_ids: The ids of subscribed contacts.
        :param str description: The description of the Subscription.
        :param int email_status: The status of email subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        :param str id: The ID of the Subscription.
        :param str item_id: The ID of the Subscription.
        :param str item_name: The name of the Subscription.
        :param int pmsg_status: The status of pmsg subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        :param int sms_status: The status of sms subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        :param int tts_status: The status of tts subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        :param Sequence[int] webhook_ids: The ids of subscribed webhooks.
        :param int webhook_status: The status of webhook subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        GetMscSubSubscriptionsSubscriptionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            channel=channel,
            contact_ids=contact_ids,
            description=description,
            email_status=email_status,
            id=id,
            item_id=item_id,
            item_name=item_name,
            pmsg_status=pmsg_status,
            sms_status=sms_status,
            tts_status=tts_status,
            webhook_ids=webhook_ids,
            webhook_status=webhook_status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             channel: Optional[str] = None,
             contact_ids: Optional[Sequence[int]] = None,
             description: Optional[str] = None,
             email_status: Optional[int] = None,
             id: Optional[str] = None,
             item_id: Optional[str] = None,
             item_name: Optional[str] = None,
             pmsg_status: Optional[int] = None,
             sms_status: Optional[int] = None,
             tts_status: Optional[int] = None,
             webhook_ids: Optional[Sequence[int]] = None,
             webhook_status: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if channel is None:
            raise TypeError("Missing 'channel' argument")
        if contact_ids is None and 'contactIds' in kwargs:
            contact_ids = kwargs['contactIds']
        if contact_ids is None:
            raise TypeError("Missing 'contact_ids' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if email_status is None and 'emailStatus' in kwargs:
            email_status = kwargs['emailStatus']
        if email_status is None:
            raise TypeError("Missing 'email_status' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if item_id is None and 'itemId' in kwargs:
            item_id = kwargs['itemId']
        if item_id is None:
            raise TypeError("Missing 'item_id' argument")
        if item_name is None and 'itemName' in kwargs:
            item_name = kwargs['itemName']
        if item_name is None:
            raise TypeError("Missing 'item_name' argument")
        if pmsg_status is None and 'pmsgStatus' in kwargs:
            pmsg_status = kwargs['pmsgStatus']
        if pmsg_status is None:
            raise TypeError("Missing 'pmsg_status' argument")
        if sms_status is None and 'smsStatus' in kwargs:
            sms_status = kwargs['smsStatus']
        if sms_status is None:
            raise TypeError("Missing 'sms_status' argument")
        if tts_status is None and 'ttsStatus' in kwargs:
            tts_status = kwargs['ttsStatus']
        if tts_status is None:
            raise TypeError("Missing 'tts_status' argument")
        if webhook_ids is None and 'webhookIds' in kwargs:
            webhook_ids = kwargs['webhookIds']
        if webhook_ids is None:
            raise TypeError("Missing 'webhook_ids' argument")
        if webhook_status is None and 'webhookStatus' in kwargs:
            webhook_status = kwargs['webhookStatus']
        if webhook_status is None:
            raise TypeError("Missing 'webhook_status' argument")

        _setter("channel", channel)
        _setter("contact_ids", contact_ids)
        _setter("description", description)
        _setter("email_status", email_status)
        _setter("id", id)
        _setter("item_id", item_id)
        _setter("item_name", item_name)
        _setter("pmsg_status", pmsg_status)
        _setter("sms_status", sms_status)
        _setter("tts_status", tts_status)
        _setter("webhook_ids", webhook_ids)
        _setter("webhook_status", webhook_status)

    @property
    @pulumi.getter
    def channel(self) -> str:
        """
        The channel the Subscription.
        """
        return pulumi.get(self, "channel")

    @property
    @pulumi.getter(name="contactIds")
    def contact_ids(self) -> Sequence[int]:
        """
        The ids of subscribed contacts.
        """
        return pulumi.get(self, "contact_ids")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Subscription.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="emailStatus")
    def email_status(self) -> int:
        """
        The status of email subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        return pulumi.get(self, "email_status")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Subscription.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> str:
        """
        The ID of the Subscription.
        """
        return pulumi.get(self, "item_id")

    @property
    @pulumi.getter(name="itemName")
    def item_name(self) -> str:
        """
        The name of the Subscription.
        """
        return pulumi.get(self, "item_name")

    @property
    @pulumi.getter(name="pmsgStatus")
    def pmsg_status(self) -> int:
        """
        The status of pmsg subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        return pulumi.get(self, "pmsg_status")

    @property
    @pulumi.getter(name="smsStatus")
    def sms_status(self) -> int:
        """
        The status of sms subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        return pulumi.get(self, "sms_status")

    @property
    @pulumi.getter(name="ttsStatus")
    def tts_status(self) -> int:
        """
        The status of tts subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        return pulumi.get(self, "tts_status")

    @property
    @pulumi.getter(name="webhookIds")
    def webhook_ids(self) -> Sequence[int]:
        """
        The ids of subscribed webhooks.
        """
        return pulumi.get(self, "webhook_ids")

    @property
    @pulumi.getter(name="webhookStatus")
    def webhook_status(self) -> int:
        """
        The status of webhook subscription. Valid values: `-1`, `-2`, `0`, `1`. `-1` means required, `-2` means banned; `1` means subscribed; `0` means not subscribed.
        """
        return pulumi.get(self, "webhook_status")


@pulumi.output_type
class GetMscSubWebhooksWebhookResult(dict):
    def __init__(__self__, *,
                 id: str,
                 server_url: str,
                 webhook_id: str,
                 webhook_name: str):
        """
        :param str id: The ID of the Webhook.
        :param str server_url: The serverUrl of the Subscription.
        :param str webhook_id: The first ID of the resource.
        :param str webhook_name: The name of the Webhook. **Note:** The name must be `2` to `12` characters in length, and can contain uppercase and lowercase letters.
        """
        GetMscSubWebhooksWebhookResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            server_url=server_url,
            webhook_id=webhook_id,
            webhook_name=webhook_name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             server_url: Optional[str] = None,
             webhook_id: Optional[str] = None,
             webhook_name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")
        if server_url is None and 'serverUrl' in kwargs:
            server_url = kwargs['serverUrl']
        if server_url is None:
            raise TypeError("Missing 'server_url' argument")
        if webhook_id is None and 'webhookId' in kwargs:
            webhook_id = kwargs['webhookId']
        if webhook_id is None:
            raise TypeError("Missing 'webhook_id' argument")
        if webhook_name is None and 'webhookName' in kwargs:
            webhook_name = kwargs['webhookName']
        if webhook_name is None:
            raise TypeError("Missing 'webhook_name' argument")

        _setter("id", id)
        _setter("server_url", server_url)
        _setter("webhook_id", webhook_id)
        _setter("webhook_name", webhook_name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Webhook.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="serverUrl")
    def server_url(self) -> str:
        """
        The serverUrl of the Subscription.
        """
        return pulumi.get(self, "server_url")

    @property
    @pulumi.getter(name="webhookId")
    def webhook_id(self) -> str:
        """
        The first ID of the resource.
        """
        return pulumi.get(self, "webhook_id")

    @property
    @pulumi.getter(name="webhookName")
    def webhook_name(self) -> str:
        """
        The name of the Webhook. **Note:** The name must be `2` to `12` characters in length, and can contain uppercase and lowercase letters.
        """
        return pulumi.get(self, "webhook_name")


@pulumi.output_type
class GetRegionsRegionResult(dict):
    def __init__(__self__, *,
                 id: str,
                 local_name: str,
                 region_id: str):
        """
        :param str id: ID of the region.
        :param str local_name: Name of the region in the local language.
        """
        GetRegionsRegionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            local_name=local_name,
            region_id=region_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             local_name: Optional[str] = None,
             region_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")
        if local_name is None and 'localName' in kwargs:
            local_name = kwargs['localName']
        if local_name is None:
            raise TypeError("Missing 'local_name' argument")
        if region_id is None and 'regionId' in kwargs:
            region_id = kwargs['regionId']
        if region_id is None:
            raise TypeError("Missing 'region_id' argument")

        _setter("id", id)
        _setter("local_name", local_name)
        _setter("region_id", region_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        ID of the region.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="localName")
    def local_name(self) -> str:
        """
        Name of the region in the local language.
        """
        return pulumi.get(self, "local_name")

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        return pulumi.get(self, "region_id")


@pulumi.output_type
class GetZonesZoneResult(dict):
    def __init__(__self__, *,
                 available_disk_categories: Sequence[str],
                 available_instance_types: Sequence[str],
                 available_resource_creations: Sequence[str],
                 id: str,
                 local_name: str,
                 multi_zone_ids: Sequence[str],
                 slb_slave_zone_ids: Sequence[str]):
        """
        :param Sequence[str] available_disk_categories: Set of supported disk categories.
        :param Sequence[str] available_instance_types: Allowed instance types.
        :param Sequence[str] available_resource_creations: Filter the results by a specific resource type.
               Valid values: `Instance`, `Disk`, `VSwitch`, `Rds`, `KVStore`, `FunctionCompute`, `Elasticsearch`, `Slb`.
               
               > **NOTE:** From version 1.134.0, the `available_resource_creation` value "Rds" has been deprecated.
               If you want to fetch the available zones for RDS instance, you can use datasource alicloud_db_zones
        :param str id: ID of the zone.
        :param str local_name: Name of the zone in the local language.
        :param Sequence[str] multi_zone_ids: A list of zone ids in which the multi zone.
        :param Sequence[str] slb_slave_zone_ids: A list of slb slave zone ids in which the slb master zone.
        """
        GetZonesZoneResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            available_disk_categories=available_disk_categories,
            available_instance_types=available_instance_types,
            available_resource_creations=available_resource_creations,
            id=id,
            local_name=local_name,
            multi_zone_ids=multi_zone_ids,
            slb_slave_zone_ids=slb_slave_zone_ids,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             available_disk_categories: Optional[Sequence[str]] = None,
             available_instance_types: Optional[Sequence[str]] = None,
             available_resource_creations: Optional[Sequence[str]] = None,
             id: Optional[str] = None,
             local_name: Optional[str] = None,
             multi_zone_ids: Optional[Sequence[str]] = None,
             slb_slave_zone_ids: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if available_disk_categories is None and 'availableDiskCategories' in kwargs:
            available_disk_categories = kwargs['availableDiskCategories']
        if available_disk_categories is None:
            raise TypeError("Missing 'available_disk_categories' argument")
        if available_instance_types is None and 'availableInstanceTypes' in kwargs:
            available_instance_types = kwargs['availableInstanceTypes']
        if available_instance_types is None:
            raise TypeError("Missing 'available_instance_types' argument")
        if available_resource_creations is None and 'availableResourceCreations' in kwargs:
            available_resource_creations = kwargs['availableResourceCreations']
        if available_resource_creations is None:
            raise TypeError("Missing 'available_resource_creations' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if local_name is None and 'localName' in kwargs:
            local_name = kwargs['localName']
        if local_name is None:
            raise TypeError("Missing 'local_name' argument")
        if multi_zone_ids is None and 'multiZoneIds' in kwargs:
            multi_zone_ids = kwargs['multiZoneIds']
        if multi_zone_ids is None:
            raise TypeError("Missing 'multi_zone_ids' argument")
        if slb_slave_zone_ids is None and 'slbSlaveZoneIds' in kwargs:
            slb_slave_zone_ids = kwargs['slbSlaveZoneIds']
        if slb_slave_zone_ids is None:
            raise TypeError("Missing 'slb_slave_zone_ids' argument")

        _setter("available_disk_categories", available_disk_categories)
        _setter("available_instance_types", available_instance_types)
        _setter("available_resource_creations", available_resource_creations)
        _setter("id", id)
        _setter("local_name", local_name)
        _setter("multi_zone_ids", multi_zone_ids)
        _setter("slb_slave_zone_ids", slb_slave_zone_ids)

    @property
    @pulumi.getter(name="availableDiskCategories")
    def available_disk_categories(self) -> Sequence[str]:
        """
        Set of supported disk categories.
        """
        return pulumi.get(self, "available_disk_categories")

    @property
    @pulumi.getter(name="availableInstanceTypes")
    def available_instance_types(self) -> Sequence[str]:
        """
        Allowed instance types.
        """
        return pulumi.get(self, "available_instance_types")

    @property
    @pulumi.getter(name="availableResourceCreations")
    def available_resource_creations(self) -> Sequence[str]:
        """
        Filter the results by a specific resource type.
        Valid values: `Instance`, `Disk`, `VSwitch`, `Rds`, `KVStore`, `FunctionCompute`, `Elasticsearch`, `Slb`.

        > **NOTE:** From version 1.134.0, the `available_resource_creation` value "Rds" has been deprecated.
        If you want to fetch the available zones for RDS instance, you can use datasource alicloud_db_zones
        """
        return pulumi.get(self, "available_resource_creations")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        ID of the zone.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="localName")
    def local_name(self) -> str:
        """
        Name of the zone in the local language.
        """
        return pulumi.get(self, "local_name")

    @property
    @pulumi.getter(name="multiZoneIds")
    def multi_zone_ids(self) -> Sequence[str]:
        """
        A list of zone ids in which the multi zone.
        """
        return pulumi.get(self, "multi_zone_ids")

    @property
    @pulumi.getter(name="slbSlaveZoneIds")
    def slb_slave_zone_ids(self) -> Sequence[str]:
        """
        A list of slb slave zone ids in which the slb master zone.
        """
        return pulumi.get(self, "slb_slave_zone_ids")


